package com.cirmuller.maidaddition.entity.behaviour;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.api.IChunkLoadingCapability;
import com.cirmuller.maidaddition.capability.ModCapability;
import com.cirmuller.maidaddition.configs.Config;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.google.common.collect.ImmutableMap;
import java.util.Map;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.behavior.Behavior;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraftforge.common.util.LazyOptional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ChunkLoadingBehaviour extends Behavior<EntityMaid> {
  private static int searchInterval = ((Integer)Config.UPDATE_RATE.get()).intValue();
  
  private static int radius = ((Integer)Config.LOADING_RADIUS.get()).intValue();
  
  private int currentTick;
  
  public static Logger logger = LogManager.getLogger("maidaddition");
  
  public ChunkLoadingBehaviour() {
    super((Map)ImmutableMap.of(MemoryRegistry.CAN_CHUNK_LOADED.get(), MemoryStatus.VALUE_PRESENT));
    this.currentTick = searchInterval;
  }
  
  protected boolean m_7773_(long time) {
    return false;
  }
  
  protected boolean checkExtraStartConditions(ServerLevel level, EntityMaid maid) {
    return true;
  }
  
  protected boolean canStillUse(ServerLevel level, EntityMaid maid, long time) {
    return (maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get()).isPresent() && ((Boolean)maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get()).get()).booleanValue());
  }
  
  protected boolean hasRequiredMemories(EntityMaid maid) {
    if (maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get()).isEmpty())
      return false; 
    return ((Boolean)maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get()).get()).booleanValue();
  }
  
  protected void tick(ServerLevel level, EntityMaid maid, long time) {
    if (this.currentTick != searchInterval) {
      this.currentTick++;
      super.m_6725_(level, (LivingEntity)maid, time);
      return;
    } 
    this.currentTick = 0;
    LazyOptional<IChunkLoadingCapability> capability = maid.getCapability(ModCapability.CHUNK_LOADING_CAPABILITY);
    capability.ifPresent(cap -> {
          cap.updateChunkLoading(radius);
          logger.info(String.format("Maid %d is loading chunks", new Object[] { Integer.valueOf(maid.m_19879_()) }));
        });
    super.m_6725_(level, (LivingEntity)maid, time);
  }
  
  protected void stop(ServerLevel level, EntityMaid maid, long time) {
    logger.info(String.format("Maid %d stops loading chunks", new Object[] { Integer.valueOf(maid.m_19879_()) }));
    super.m_6732_(level, (LivingEntity)maid, time);
  }
  
  protected void start(ServerLevel p_22540_, EntityMaid p_22541_, long p_22542_) {
    super.m_6735_(p_22540_, (LivingEntity)p_22541_, p_22542_);
  }
}
